﻿namespace ResticLogParser.src
{
    internal readonly struct FileLogEntry : IComparable<FileLogEntry>
    {
        public FileLogEntry(string fileName, FileLogEntryType type, long addedSize)
            : this(fileName, type, addedSize, addedSize)
        {
        }

        public FileLogEntry(string fileName, FileLogEntryType type, long addedSize, long storedSize)
        {
            FileName = fileName;
            Type = type;
            AddedSize = addedSize;
            StoredSize = storedSize;
        }

        public string FileName { get; init; }

        public FileLogEntryType Type { get; init; }

        public long AddedSize { get; init; }

        public long StoredSize { get; init; }

        public int CompareTo(FileLogEntry other)
        {
            return AddedSize.CompareTo(other.AddedSize);
        }

        public override string ToString()
        {
            return $"{Type}, added {AddedSize} bytes, {FileName}";
        }
    }
}
