﻿using System.Globalization;

namespace ResticLogParser.src
{
    public class FileSize
    {
        public static long GetBytesFromString(string fileSizeText)
        {
            string[] split = fileSizeText.Split(" ", StringSplitOptions.TrimEntries);
            if (split.Length < 2 || split[0].Length < 1 || split[1].Length < 1 || split[1].Length > 3
                || split[1][split[1].Length - 1] != 'B')
            {
                return 0;
            }
            var value = double.Parse(split[0], CultureInfo.InvariantCulture.NumberFormat);
            var power = split[1].Length > 1
                ? split[1][0] switch
                    {
                        'K' => 1,
                        'M' => 2,
                        'G' => 3,
                        'T' => 4,
                        _ => 0
                    }
                : 0;

            int valueBase;
            if (split[1].Length < 3)
            {
                valueBase = 1000;
            }
            else if (split[1][1] == 'i')
            {
                valueBase = 1024;
            }
            else
            {
                return 0;
            }

            var s = Math.Pow(valueBase, power);
            var t = value * Math.Pow(valueBase, power);
            return (long)Math.Round(value * Math.Pow(valueBase, power));
        }
    }
}
